> ## Documentation Index
> Fetch the complete documentation index at: https://docs.magichour.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Face Swap Photo API Reference - Magic Hour Docs

> Create a face swap photo. Each photo costs 10 credits. The height/width of the output image depends on your subscription. Please refer to our [pricing](https://magichour.ai/pricing) page for more details



## OpenAPI

````yaml post /v1/face-swap-photo
openapi: 3.0.2
info:
  title: Magic Hour API
  version: beta
  description: >

    Magic Hour provides an API (beta) that can be integrated into your own
    application to generate videos and images using AI. 


    Webhook documentation can be found
    [here](https://magichour.ai/docs/webhook).


    If you have any questions, please reach out to us via
    [discord](https://discord.gg/JX5rgsZaJp).


    # Authentication


    Every request requires an API key.


    To get started, first generate your API key
    [here](https://magichour.ai/settings/developer).


    Then, add the `Authorization` header to the request.


    | Key | Value |

    |-|-|

    | Authorization | Bearer mhk_live_apikey |


    > **Warning**: any API call that renders a video will utilize credits in
    your account.
  termsOfService: https://magichour.ai/terms-of-service
servers:
  - url: https://api.magichour.ai
security: []
tags:
  - name: Files
    description: API related to uploading assets used for video generation
  - name: Image Projects
    description: API related to image projects
  - name: Video Projects
    description: API related to video projects
  - name: Audio Projects
    description: API related to audio projects
paths:
  /v1/face-swap-photo:
    post:
      tags:
        - Image Projects
      summary: Face Swap Photo
      description: >-
        Create a face swap photo. Each photo costs 10 credits. The height/width
        of the output image depends on your subscription. Please refer to our
        [pricing](https://magichour.ai/pricing) page for more details
      operationId: faceSwapPhoto.createImage
      parameters: []
      requestBody:
        required: true
        description: Body
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  description: Give your image a custom name for easy identification.
                  example: My Face Swap image
                  default: Face Swap - dateTime
                assets:
                  type: object
                  properties:
                    face_swap_mode:
                      default: all-faces
                      type: string
                      enum:
                        - all-faces
                        - individual-faces
                      description: >-
                        Choose how to swap faces:

                        **all-faces** (recommended) — swap all detected faces
                        using one source image (`source_file_path` required)

                        +- **individual-faces** — specify exact mappings using
                        `face_mappings`
                      example: all-faces
                    source_file_path:
                      type: string
                      minLength: 1
                      description: >
                        This is the image from which the face is extracted. The
                        value is required if `face_swap_mode` is `all-faces`.


                        This value is either

                        - a direct URL to the video file

                        - `file_path` field from the response of the [upload
                        urls
                        API](https://docs.magichour.ai/api-reference/files/generate-asset-upload-urls).


                        See the [file upload
                        guide](https://docs.magichour.ai/api-reference/files/generate-asset-upload-urls#input-file)
                        for details.
                      example: api-assets/id/1234.png
                    face_mappings:
                      type: array
                      items:
                        type: object
                        properties:
                          original_face:
                            type: string
                            description: >-
                              The face detected from the image in
                              `target_file_path`. The file name is in the format
                              of `<face_frame>-<face_index>.png`. This value is
                              corresponds to the response in the [face detection
                              API](https://docs.magichour.ai/api-reference/files/get-face-detection-details).


                              * The face_frame is the frame number of the face
                              in the target image. For images, the frame number
                              is always 0.

                              * The face_index is the index of the face in the
                              target image, starting from 0 going left to right.
                            example: api-assets/id/0-0.png
                          new_face:
                            type: string
                            description: >
                              The face image that will be used to replace the
                              face in the `original_face`. This value is either

                              - a direct URL to the video file

                              - `file_path` field from the response of the
                              [upload urls
                              API](https://docs.magichour.ai/api-reference/files/generate-asset-upload-urls).


                              See the [file upload
                              guide](https://docs.magichour.ai/api-reference/files/generate-asset-upload-urls#input-file)
                              for details.
                            example: api-assets/id/1234.png
                        required:
                          - original_face
                          - new_face
                      maxItems: 5
                      description: >-
                        This is the array of face mappings used for multiple
                        face swap. The value is required if `face_swap_mode` is
                        `individual-faces`.
                      example:
                        - original_face: api-assets/id/0-0.png
                          new_face: api-assets/id/1234.png
                    target_file_path:
                      type: string
                      minLength: 1
                      description: >
                        This is the image where the face from the source image
                        will be placed. This value is either

                        - a direct URL to the video file

                        - `file_path` field from the response of the [upload
                        urls
                        API](https://docs.magichour.ai/api-reference/files/generate-asset-upload-urls).


                        See the [file upload
                        guide](https://docs.magichour.ai/api-reference/files/generate-asset-upload-urls#input-file)
                        for details.
                      example: api-assets/id/1234.png
                  required:
                    - target_file_path
                  description: Provide the assets for face swap photo
              required:
                - assets
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                    example: cuid-example
                    description: >-
                      Unique ID of the image. Use it with the [Get image Project
                      API](https://docs.magichour.ai/api-reference/image-projects/get-image-details)
                      to fetch status and downloads.
                  credits_charged:
                    type: integer
                    description: >-
                      The amount of credits deducted from your account to
                      generate the image. We charge credits right when the
                      request is made. 


                      If an error occurred while generating the image(s),
                      credits will be refunded and this field will be updated to
                      include the refund.
                    example: 10
                required:
                  - id
                  - frame_cost
                  - credits_charged
                description: Success
        '400':
          description: Invalid Request
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                required:
                  - message
                description: The request is invalid
                example:
                  message: Missing request body
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                    enum:
                      - Unauthorized
                required:
                  - message
                description: The request is not properly authenticated
                example:
                  message: Unauthorized
        '402':
          description: Payment Required
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                required:
                  - message
                description: The request requires payment
                example:
                  message: Payment required
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                    enum:
                      - Not Found
                required:
                  - message
                description: Requested resource is not found
                example:
                  message: Not Found
        '422':
          description: Unprocessable Entity
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                    example: Unable to create image
                required:
                  - message
                description: Unprocessable Entity
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: python
          source: |-
            from magic_hour import Client
            from os import getenv

            client = Client(token=getenv("API_TOKEN"))
            res = client.v1.face_swap_photo.generate(
                assets={
                    "face_mappings": [
                        {
                            "new_face": "/path/to/1234.png",
                            "original_face": "api-assets/id/0-0.png",
                        }
                    ],
                    "face_swap_mode": "all-faces",
                    "source_file_path": "/path/to/1234.png",
                    "target_file_path": "/path/to/1234.png",
                },
                name="Face Swap image",
                wait_for_completion=True,
                download_outputs=True,
                download_directory="."
            )
        - lang: javascript
          source: |-
            import { Client } from "magic-hour";

            const client = new Client({ token: process.env["API_TOKEN"]!! });
            const res = await client.v1.faceSwapPhoto.generate(
              {
                assets: {
                  faceMappings: [
                    {
                      newFace: "api-assets/id/1234.png",
                      originalFace: "api-assets/id/0-0.png",
                    },
                  ],
                  faceSwapMode: "all-faces",
                  sourceFilePath: "/path/to/1234.png",
                  targetFilePath: "/path/to/1234.png",
                },
                name: "Face Swap image",
              },
              {
                waitForCompletion: true,
                downloadOutputs: true,
                downloadDirectory: ".",
              },
            );
        - lang: go
          source: "package main\n\nimport (\n\tos \"os\"\n\n\tsdk \"github.com/magichourhq/magic-hour-go/client\"\n\tnullable \"github.com/magichourhq/magic-hour-go/nullable\"\n\tface_swap_photo \"github.com/magichourhq/magic-hour-go/resources/v1/face_swap_photo\"\n\ttypes \"github.com/magichourhq/magic-hour-go/types\"\n)\n\nfunc main() {\n\tclient := sdk.NewClient(\n\t\tsdk.WithBearerAuth(os.Getenv(\"API_TOKEN\")),\n\t)\n\tres, err := client.V1.FaceSwapPhoto.Create(face_swap_photo.CreateRequest{\n\t\tAssets: types.V1FaceSwapPhotoCreateBodyAssets{\n\t\t\tFaceMappings: nullable.NewValue([]types.V1FaceSwapPhotoCreateBodyAssetsFaceMappingsItem{\n\t\t\t\ttypes.V1FaceSwapPhotoCreateBodyAssetsFaceMappingsItem{\n\t\t\t\t\tNewFace:      \"api-assets/id/1234.png\",\n\t\t\t\t\tOriginalFace: \"api-assets/id/0-0.png\",\n\t\t\t\t},\n\t\t\t}),\n\t\t\tFaceSwapMode:   nullable.NewValue(types.V1FaceSwapPhotoCreateBodyAssetsFaceSwapModeEnumAllFaces),\n\t\t\tSourceFilePath: nullable.NewValue(\"api-assets/id/1234.png\"),\n\t\t\tTargetFilePath: \"api-assets/id/1234.png\",\n\t\t},\n\t\tName: nullable.NewValue(\"My Face Swap image\"),\n\t})\n}"
        - lang: rust
          source: |-
            let client = magic_hour::Client::default()
                .with_bearer_auth(&std::env::var("API_TOKEN").unwrap());
            let res = client
                .v1()
                .face_swap_photo()
                .create(magic_hour::resources::v1::face_swap_photo::CreateRequest {
                    assets: magic_hour::models::V1FaceSwapPhotoCreateBodyAssets {
                        face_mappings: Some(
                            vec![
                                magic_hour::models::V1FaceSwapPhotoCreateBodyAssetsFaceMappingsItem
                                { new_face : "api-assets/id/1234.png".to_string(), original_face
                                : "api-assets/id/0-0.png".to_string() }
                            ],
                        ),
                        face_swap_mode: Some(
                            magic_hour::models::V1FaceSwapPhotoCreateBodyAssetsFaceSwapModeEnum::AllFaces,
                        ),
                        source_file_path: Some("api-assets/id/1234.png".to_string()),
                        target_file_path: "api-assets/id/1234.png".to_string(),
                    },
                    name: Some("My Face Swap image".to_string()),
                })
                .await;
        - lang: curl
          source: |-
            curl --request POST \
                 --url https://api.magichour.ai/v1/face-swap-photo \
                 --header 'accept: application/json' \
                 --header 'authorization: Bearer <token>' \
                 --header 'content-type: application/json' \
                 --data '
            {
              "name": "My Face Swap image",
              "assets": {
                "face_swap_mode": "all-faces",
                "source_file_path": "api-assets/id/1234.png",
                "face_mappings": [
                  {
                    "original_face": "api-assets/id/0-0.png",
                    "new_face": "api-assets/id/1234.png"
                  }
                ],
                "target_file_path": "api-assets/id/1234.png"
              }
            }
            '
        - lang: php
          source: |-
            <?php

            $curl = curl_init();

            curl_setopt_array($curl, [
              CURLOPT_URL => "https://api.magichour.ai/v1/face-swap-photo",
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => "",
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => "POST",
              CURLOPT_POSTFIELDS => json_encode([
                'name' => 'My Face Swap image',
                'assets' => [
                    'face_swap_mode' => 'all-faces',
                    'source_file_path' => 'api-assets/id/1234.png',
                    'face_mappings' => [
                            [
                                            'original_face' => 'api-assets/id/0-0.png',
                                            'new_face' => 'api-assets/id/1234.png'
                            ]
                    ],
                    'target_file_path' => 'api-assets/id/1234.png'
                ]
              ]),
              CURLOPT_HTTPHEADER => [
                "accept: application/json",
                "authorization: Bearer <token>",
                "content-type: application/json"
              ],
            ]);

            $response = curl_exec($curl);
            $err = curl_error($curl);

            curl_close($curl);

            if ($err) {
              echo "cURL Error #:" . $err;
            } else {
              echo $response;
            }
        - lang: java
          source: >-
            HttpResponse<String> response =
            Unirest.post("https://api.magichour.ai/v1/face-swap-photo")
              .header("accept", "application/json")
              .header("content-type", "application/json")
              .header("authorization", "Bearer <token>")
              .body("{\"name\":\"My Face Swap image\",\"assets\":{\"face_swap_mode\":\"all-faces\",\"source_file_path\":\"api-assets/id/1234.png\",\"face_mappings\":[{\"original_face\":\"api-assets/id/0-0.png\",\"new_face\":\"api-assets/id/1234.png\"}],\"target_file_path\":\"api-assets/id/1234.png\"}}")
              .asString();
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: >-
        Bearer authentication header of the form `Bearer <api_key>`, where
        `<api_key>` is your API key. To get your API key, go to [Developer
        Hub](https://magichour.ai/developer?tab=api-keys) and click "Create new
        API Key".

````